clear;clc;close all;
global N ;%Antenna number of BS
N = 1;
global Kt ;%用户数
Kt = 2;
NUM = 100; %信道次数
q = 1;
Rr_values = [1.0, 1.1, 1.2, 1.3, 1.4, 1.5, 1.6, 1.7, 1.8, 1.9, 2.0]; % Rr的范围
T = 1;%通信时间
eta = 0.8;%能量转化效率

% Initialize arrays to store results
sum_result = zeros(length(Rr_values), 1);

for r_idx = 1:length(Rr_values)
    Rr = [Rr_values(r_idx), Rr_values(r_idx)]; % Update Rr for current iteration
    result = zeros(1, length(40:2:40)); % Initialize result array for current Rr
for P_max = 40:2:40%AP发射功率dBm
    Pmax=10.^(P_max/10);%转换成dBm
Ka_Los = 3;
pno = sqrt(10.^(-80/10));
%位置
x_AP = 10;%AP位置
x_I = 0;%IRS位置
for i = 1:Kt
x_Ut(i) = unifrnd(0,1.5)*exp(1i*unifrnd(-pi/2,pi/2));    
d_Ir(i) = abs(x_I-x_Ut(i));
d_Ar(i) = abs(x_AP-x_Ut(i));
end
p = 1;

%角度信息
angle_AI = atan((imag(x_I)-imag(x_AP))/(real(x_I)-real(x_AP)));
for i = 1:Kt
    angle_AUt(i) = atan((imag(x_AP)-imag(x_Ut(i)))/(real(x_AP)-real(x_Ut(i))));
    angle_IUt(i) = atan((imag(x_I)-imag(x_Ut(i)))/(real(x_I)-real(x_Ut(i))));
end
for ch = 1:NUM
% channel initialization
for i = 1:Kt
h_AUt_NLos(:,i) = 1/sqrt(2)*(normrnd(0,1,N,1)+1i*normrnd(0,1,N,1));
h_AUt(:,i) = sqrt(0.001*(abs(d_Ar(i)))^(-3.5))*h_AUt_NLos(:,i);%AP到用户信道
end
h_AUt = h_AUt/pno;

%用户间信道
KK = (Kt*(Kt-1))/2;
for i = 1:KK
    h_Ut_NLos(:,i) = 1/sqrt(2)*(normrnd(0,1,1,1)+1i*normrnd(0,1,1,1));
end
z = 1;
for i = 1:Kt
    for j = (i+1):Kt
        if (i<j)
            h_U(z) = sqrt(0.001*(abs(x_Ut(j)-x_Ut(i)))^(-2.4))*h_Ut_NLos(:,z);%用户间信道
            z = z+1;
        end     
    end
end
h_U = h_U/pno;

q_k = h_AUt';
qk_U = h_U';


t0_0 = 0.001;
for i = 1:Kt
    t1_0(i) = (1-t0_0)/Kt;
end
P1_0 = 1;
P2_0 = ones(1,2);
P3_0 = ones(1,2);
y0 = 5*ones(1,Kt-1);
mu(1) = 1;
mu(2) = 1;
ns = 1;
r_sum = 0;
r_sum0 = 0;
number = 0;

ns = 1;
while(1)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%RIS系数和Device功率分配
cvx_begin 
            variables P1 P2(2) P3(2) x(Kt-1) y(Kt-1) z(Kt-1)

            
            minimize(0)
            subject to

                
                for i = 1:2
                   P2(i) >= 0;
                   P3(i) >= 0;
                end
                P1 >= 0;



              %k=1
                P1*real(q_k(1,:)'*q_k(1,:)) >= 2^(Rr(1)/t1_0(1))-1;
                P1*t1_0(1) <= eta*Pmax*t0_0*real(q_k(1,:)'*q_k(1,:));

                %k=2
                Rr(2) <= t1_0(1)*x(1)-t1_0(1)*y(1)+t1_0(2)*z(1);

                2^x(1) <= 1+P1*real(q_k(1,:)'*q_k(1,:))+P2(1)*real(q_k(2,:)'*q_k(2,:));

                2^z(1) <= 1+P2(2)*real(q_k(2,:)'*q_k(2,:));

                2^y0(1)+2^y0(1)*(y(1)-y0(1))*log(2) >= 1+P1*real(q_k(1,:)'*q_k(1,:));
                
                P2(1)*t1_0(1)+P2(2)*t1_0(2) <= eta*Pmax*t0_0*(real(q_k(2,:)'*q_k(2,:)));

cvx_end
if cvx_optval==-Inf
	break;
end 

P1_0 = P1;
P2_0 = P2;
P3_0 = P3;
y0 = y;




%优化时间系数
cvx_begin 
            variables t1(Kt) t0
            minimize(Pmax*t0)
            subject to
                
                t0 >= 0;
                t1 >= 0;
                t0+sum(t1) <= T;

                %k=1
                P1*t1(1) <= eta*Pmax*t0*norm(q_k(1,:),2)^2;
                %k=2
                P2(1)*t1(1)+P2(2)*t1(2) <= eta*Pmax*t0*norm(q_k(2,:),2)^2;

                %k=1
                t1(1)*log2(1+P1*norm(q_k(1,:),2)^2) >= Rr(1);
                %k=2
                t1(1)*log2(1+P2(1)*norm(q_k(2,:),2)^2/(P1*norm(q_k(1,:),2)^2+1))+t1(2)*log2(1+P2(2)*norm(q_k(2,:),2)^2) >= Rr(2);

cvx_end

t0_0 = t0;
t1_0 = t1;


rsum(ns) = cvx_optval;%检查收敛性
if(ns>2)&&(abs(cvx_optval-r_sum0)<=0.1)
%if(ns>51)
    break;
end
if (ns>21)
    break;
end
r_sum0 = cvx_optval;

ns = ns+1;
end
result(p) = cvx_optval;
p = p+1;
end
sum_result(q) = sum(result(:))/length(result(result>0));
q = q+1;
end
end
% 绘图
figure;
plot(Rr_values, sum_result, '-o');
xlabel('Rr');
ylabel('Average Sum Result');
title('Average Sum Result vs Rr');
grid on;