clear;clc;close all;
global N ;%Antenna number of BS
N = 1;
global M ;%IRS elemnt number
M = 30;
global Kt ;%用户数
Kt = 2;
NUM = 100; %信道次数
q = 1;
Rr = [1,1];%最小速率
eta = 0.8;%能量转化效率
T_values = [0.6, 0.8, 1.0, 1.2, 1.4, 1.6, 1.8, 2.0];
sum_result = zeros(1, length(T_values)); % 初始化sum_result数组

for idx_T = 1:length(T_values)
    T = T_values(idx_T); % 设置当前T值
for P_max = 40:2:40%AP发射功率dBm
    Pmax=10.^(P_max/10);%转换成dBm
Ka_Los = 3;
pno = sqrt(10.^(-80/10));
%位置
x_AP = 10;%AP位置
x_I = 0;%IRS位置
for i = 1:Kt
x_Ut(i) = unifrnd(0,1.5)*exp(1i*unifrnd(-pi/2,pi/2));    
d_Ir(i) = abs(x_I-x_Ut(i));
d_Ar(i) = abs(x_AP-x_Ut(i));
end
p = 1;

for ch = 1:NUM
% channel initialization
a_IUt_t = 1;
for i = 2:M
    a_IUt_t = [a_IUt_t,exp(1i*2*pi*(i-1)*sin(pi/4))];
end
for i = 1:Kt
h_AUt_NLos(:,i) = 1/sqrt(2)*(normrnd(0,1,N,1)+1i*normrnd(0,1,N,1));
h_AUt(:,i) = sqrt(0.001*(abs(d_Ar(i)))^(-3.5))*h_AUt_NLos(:,i);%AP到用户信道
h_IUt_Los(:,i) = a_IUt_t';
h_IUt_NLos(:,i) = 1/sqrt(2)*(normrnd(0,1,M,1)+1i*normrnd(0,1,M,1));
h_IUt(:,i) = (sqrt(0.001*(abs(d_Ir(i)))^(-2.2)*Ka_Los/(Ka_Los+1))*h_IUt_Los(:,i)+sqrt(0.001*(abs(d_Ir(i)))^(-2.2)/(Ka_Los+1))*h_IUt_NLos(:,i));%RIS鍒扮敤鎴蜂俊閬?
end
h_AUt = h_AUt/pno;

%用户间信道
KK = (Kt*(Kt-1))/2;
for i = 1:KK
    h_Ut_NLos(:,i) = 1/sqrt(2)*(normrnd(0,1,1,1)+1i*normrnd(0,1,1,1));
end
z = 1;
for i = 1:Kt
    for j = (i+1):Kt
        if (i<j)
            h_U(z) = sqrt(0.001*(abs(x_Ut(j)-x_Ut(i)))^(-2.4))*h_Ut_NLos(:,z);%用户间信道
            z = z+1;
        end     
    end
end
h_U = h_U/pno;

G_NLoS = 1/sqrt(2)*(normrnd(0,1,M,N)+1i*normrnd(0,1,M,N));%AP到RIS的NLoS信道
G_LoS_t = 1;
G_LoS_r = 1;
d_r_lamda = 0.5;
ang_G_t = atan(0.1);
ang_G_r = pi-ang_G_t;
for i = 2:N
    G_LoS_t = [G_LoS_t,exp(1i*2*pi*(i-1)*d_r_lamda*sin(ang_G_t))];
end
for i = 2:M
    G_LoS_r = [G_LoS_r,exp(1i*2*pi*(i-1)*d_r_lamda*sin(ang_G_r))];
end
G_LoS = G_LoS_r'*G_LoS_t;

H = sqrt(0.001*(abs(x_AP-x_I))^(-2.2)*Ka_Los/(Ka_Los+1))*G_LoS+sqrt(0.001*(abs(x_AP-x_I))^(-2.2)*1/(Ka_Los+1))*G_NLoS;%RIS鍒癆P淇￠亾
H = H/pno;

for i = 1:Kt
    qk(i,:) = h_IUt(:,i)'*diag(H);
end
for i = 1:Kt
    q_k(i,:) = [qk(i,:),h_AUt(:,i)];
end

z = 1;
for i = 1:Kt
    for j = (i+1):Kt
        if (i<j)
            qkU(z,:) = h_IUt(:,i)'*diag(h_IUt(:,j));
            z = z+1;
        end     
    end
end
for i = 1:KK
    qk_U(i,:) = [qkU(i,:),h_U(i)];
end



%设置初始值
%u0 = 0;
% 设置初始值
fixed_value = (1/sqrt(2)) * (randn(M+1, 1) + 1i * randn(M+1, 1)); %固定值

for j = 1:(Kt + 1)
    u0(:, j) = fixed_value; % 赋固定值给每个用户
end



t0_0 = 0.001;
for i = 1:Kt
    t1_0(i) = (1-t0_0)/Kt;
end
P1_0 = 1;
P2_0 = ones(1,2);
P3_0 = ones(1,2);
y0 = 5*ones(1,Kt-1);
mu(1) = 1;
mu(2) = 1;
ns = 1;
r_sum = 0;
r_sum0 = 0;
number = 0;

ns = 1;
while(1)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%RIS系数和Device功率分配
cvx_begin 
            variables P1 P2(2) P3(2) x(Kt-1) y(Kt-1) z(Kt-1)
            variable u(M+1,Kt+1) complex
            
            minimize(0)
            subject to

             for i = 1:(M+1)
                    for j = 1:(Kt+1)
                        pow_abs(u(i,j),1) <= 1;
                    end
             end
                
                for i = 1:2
                   P2(i) >= 0;
                   P3(i) >= 0;
                end
                P1 >= 0;



                %k=1
                2*P1_0*real(u0(:,1)'*q_k(1,:)'*q_k(1,:)*u(:,1))-P1_0^2*real(u0(:,1)'*q_k(1,:)'*q_k(1,:)*u0(:,1))*inv_pos(P1) >= 2^(Rr(1)/t1_0(1))-1;
                P1*t1_0(1) <= eta*Pmax*t0_0*(2*real(u0(:,Kt+1)'*q_k(1,:)'*q_k(1,:)*u(:,Kt+1))-real(u0(:,Kt+1)'*q_k(1,:)'*q_k(1,:)*u0(:,Kt+1)));

                %k=2
                Rr(2) <= t1_0(1)*x(1)-t1_0(1)*y(1)+t1_0(2)*z(1);

                2^x(1) <= 1+2*P1_0*real(u0(:,1)'*q_k(1,:)'*q_k(1,:)*u(:,1))-P1_0^2*real(u0(:,1)'*q_k(1,:)'*q_k(1,:)*u0(:,1))*inv_pos(P1)+2*P2_0(1)*real(u0(:,1)'*q_k(2,:)'*q_k(2,:)*u(:,1))-P2_0(1)^2*real(u0(:,1)'*q_k(2,:)'*q_k(2,:)*u0(:,1))*inv_pos(P2(1));

                2^z(1) <= 1+2*P2_0(2)*real(u0(:,2)'*q_k(2,:)'*q_k(2,:)*u(:,2))-P2_0(2)^2*real(u0(:,2)'*q_k(2,:)'*q_k(2,:)*u0(:,2))*inv_pos(P2(2));

                2^y0(1)+2^y0(1)*(y(1)-y0(1))*log(2) >= 1+0.5*mu(1)*P1^2+1/(2*mu(1))*pow_abs(q_k(1,:)*u(:,1),4);

                P2(1)*t1_0(1)+P2(2)*t1_0(2) <= eta*Pmax*t0_0*(2*real(u0(:,Kt+1)'*q_k(2,:)'*q_k(2,:)*u(:,Kt+1))-real(u0(:,Kt+1)'*q_k(2,:)'*q_k(2,:)*u0(:,Kt+1)));

cvx_end
if cvx_optval==-Inf
	break;
end 

P1_0 = P1;
P2_0 = P2;
P3_0 = P3;
y0 = y;
u0 = u;
mu(1) = norm(q_k(1,:)*u(:,1),2)^2/P1;
mu(2) = norm(q_k(2,:)*u(:,2),2)^2/P2(2);



%优化时间系数
cvx_begin 
            variables t1(Kt) t0
            minimize(Pmax*t0)
            subject to
                
                t0 >= 0;
                t1 >= 0;
                t0+sum(t1) <= T;

                %k=1
                P1*t1(1) <= eta*Pmax*t0*norm(q_k(1,:)*u0(:,Kt+1),2)^2;
                %k=2
                P2(1)*t1(1)+P2(2)*t1(2) <= eta*Pmax*t0*norm(q_k(2,:)*u0(:,Kt+1),2)^2;

                %k=1
                t1(1)*log2(1+P1*norm(q_k(1,:)*u0(:,1),2)^2) >= Rr(1);
                %k=2
                t1(1)*log2(1+P2(1)*norm(q_k(2,:)*u0(:,1),2)^2/(P1*norm(q_k(1,:)*u0(:,1),2)^2+1))+t1(2)*log2(1+P2(2)*norm(q_k(2,:)*u0(:,2),2)^2) >= Rr(2);

cvx_end

t0_0 = t0;
t1_0 = t1;


rsum(ns) = cvx_optval;%检查收敛性
if(ns>2)&&(abs(cvx_optval-r_sum0)<=0.1)
%if(ns>51)
    break;
end
if (ns>21)
    break;
end
r_sum0 = cvx_optval;

ns = ns+1;
end
result(p) = cvx_optval;
p = p+1;
end
sum_result(q) = sum(result(:))/length(result(result>0));
q = q+1;
end
end

% 绘制sum_result与T的关系图
figure;
plot(T_values, sum_result, '-o');
xlabel('T values');
ylabel('Sum result');
title('Sum result vs. T values');
grid on;
