clear;clc;close all;
global N ;%Antenna number of BS
N = 1;
global Kt ;%用户数
Kt = 2;
NUM = 100; %信道次数
global M ;%IRS elemnt number
M = 30;
q = 1;
Rr = [1,1];%最小速率
eta = 0.8;%能量转化效率
T_values = [0.6, 0.8, 1.0, 1.2, 1.4, 1.6, 1.8, 2.0];
sum_result = zeros(1, length(T_values)); % 初始化sum_result数组

for idx_T = 1:length(T_values)
    T = T_values(idx_T); % 设置当前T值

for P_max = 40:2:40%AP发射功率dBm
Pmax=10.^((P_max)/10);%转换成dBm
Ka_Los = 3;
pno = sqrt(10.^(-80/10));
x_I = 0;%IRS位置
x_AP = 10;%AP位置
x_Ut(1) = -0.5;
x_Ut(2) = 0.25-1i*sqrt(3)/4;
for i = 1:Kt
d_Ir(i) = abs(x_I-x_Ut(i));
d_Ar(i) = abs(x_AP-x_Ut(i));
end
p = 1;
%角度信息
angle_AI = atan((imag(x_I)-imag(x_AP))/(real(x_I)-real(x_AP)));
for i = 1:Kt
    angle_AUt(i) = atan((imag(x_AP)-imag(x_Ut(i)))/(real(x_AP)-real(x_Ut(i))));
    angle_IUt(i) = atan((imag(x_I)-imag(x_Ut(i)))/(real(x_I)-real(x_Ut(i))));
end
for i = 1:M
for j = 1:Kt
h_IUt_Los(i,j) = 0;
h_IUt_NLos(i,j) = 0;
h_IUt(i,j) = 0;
qk(j,i) = 0;
end
end

for i = 1:M+1
    for j = 1:Kt
        q_k(j,i) = 0;
    end
end

for j = 1:(Kt+1)
    for i = 1:M+1
        u0(i,j) = 0;
    end
end

for ch = 1:NUM
% channel initialization
a_IUt_t1 = 1;
a_IUt_t2 = 1;
for i = 2:M
    a_IUt_t1 = [a_IUt_t1,exp(1i*2*pi*(i-1)*sin(angle_IUt(1)))];
    a_IUt_t2 = [a_IUt_t2,exp(1i*2*pi*(i-1)*sin(angle_IUt(2)))];
end
h_IUt_Los(:,1) = a_IUt_t1';
h_IUt_Los(:,2) = a_IUt_t2';
for i = 1:Kt
h_AUt_NLos(:,i) = 1/sqrt(2)*(normrnd(0,1,N,1)+1i*normrnd(0,1,N,1));
h_AUt(:,i) = sqrt(0.001*(abs(d_Ar(i)))^(-3.5))*h_AUt_NLos(:,i);%AP到用户信道
h_IUt_NLos(:,i) = 1/sqrt(2)*(normrnd(0,1,M,1)+1i*normrnd(0,1,M,1));
h_IUt(:,i) = (sqrt(0.001*(abs(d_Ir(i)))^(-2.2)*Ka_Los/(Ka_Los+1))*h_IUt_Los(:,i)+sqrt(0.001*(abs(d_Ir(i)))^(-2.2)/(Ka_Los+1))*h_IUt_NLos(:,i));%RIS到用户信道
end
h_AUt = h_AUt/pno;

G_NLoS = 1/sqrt(2)*(normrnd(0,1,M,N)+1i*normrnd(0,1,M,N));%AP到RIS的NLoS信道
G_LoS_t = 1;
G_LoS_r = 1;
for i = 2:N
    G_LoS_t = [G_LoS_t,exp(1i*2*pi*(i-1)*sin(angle_AI))];
end
for i = 2:M
    G_LoS_r = [G_LoS_r,exp(1i*2*pi*(i-1)*sin(pi-angle_AI))];
end
G_LoS = G_LoS_r'*G_LoS_t;

H = sqrt(0.001*(abs(x_AP-x_I))^(-2.2)*Ka_Los/(Ka_Los+1))*G_LoS+sqrt(0.001*(abs(x_AP-x_I))^(-2.2)*1/(Ka_Los+1))*G_NLoS;%RIS到AP信道
H = H/pno;

for i = 1:Kt
    qk(i,:) = h_IUt(:,i)'*diag(H);
end

for i = 1:Kt
    q_k(i,:) = [qk(i,:),h_AUt(:,i)];
end


%设置初始值
u0 = 0;
u_r = 1/sqrt(2)*(normrnd(0,1,M,1)+1i*normrnd(0,1,M,1));
for i = 1:M
    u0(i,1) = sqrt(0.5)*(u_r(i)/abs(u_r(i)));
end
u0 = [u0;1];%初始IRS系数

t0_0 = 0.001;
t1_0 = 0.99;
mu(1) = 1;
mu(2) = 1;
d0(1) = 20;
d0(2) = 10;
ns = 1;
r_sum = 0;
r_sum0 = 0;
number = 0;


ns = 1;
while(1)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%优化发射波束
cvx_begin
            variables t0 t1 a(Kt) b(Kt) c(Kt) d(Kt)
            variable u(M+1) complex
            
            minimize(Pmax*t0)
            subject to
                
                a >= 0;
                b >= 0;
                c >= 0;
                d >= 0;
                t0 >= 0;
                t1 >= 0;

                t0+t1 <= T;

                for i = 1:M
                    abs(u(i)) <= 1;
                end

                u(M+1) == 1+0*1i;

                a(1)-b(1) >= Rr(1);
                a(2)-b(2) >= Rr(2);

                a(1) <= -1/log(2)*rel_entr(t1,t1+c(1));
                a(2) <= -1/log(2)*rel_entr(t1,t1+c(2));

                b(1) >= t1_0/log(2)*log(1+d0(1)/t1_0)+(t1_0/(t1_0+d0(1)))*(d(1)-d0(1))+(1/log(2)*log(1+d0(1)/t1_0)-d0(1)/(d0(1)+t1_0))*(t1-t1_0);
                b(2) >= t1_0/log(2)*log(1+d0(2)/t1_0)+(t1_0/(t1_0+d0(2)))*(d(2)-d0(2))+(1/log(2)*log(1+d0(2)/t1_0)-d0(2)/(d0(2)+t1_0))*(t1-t1_0);

                c(1) <= eta*Pmax*(4*t0_0*square_abs(q_k(1,:)*u0)*real(u0'*q_k(1,:)'*q_k(1,:)*u)-2*real(u0'*q_k(1,:)'*q_k(1,:)*u0)^2*t0_0^1.5*inv_pos(sqrt(t0))-real(u'*q_k(1,:)'*q_k(1,:)*u0)*t0_0+4*t0_0*square_abs(q_k(2,:)*u0)*real(u0'*q_k(2,:)'*q_k(2,:)*u)-2*real(u0'*q_k(2,:)'*q_k(2,:)*u0)^2*t0_0^1.5*inv_pos(sqrt(t0))-real(u'*q_k(2,:)'*q_k(2,:)*u0)*t0_0);%+4*t0_0*square_abs(q_k(3,:)*u0)*real(u0'*q_k(3,:)'*q_k(3,:)*u)-2*real(u0'*q_k(3,:)'*q_k(3,:)*u0)^2*t0_0^1.5*inv_pos(sqrt(t0))-real(u'*q_k(3,:)'*q_k(3,:)*u0)*t0_0);
                c(2) <= eta*Pmax*(4*t0_0*square_abs(q_k(2,:)*u0)*real(u0'*q_k(2,:)'*q_k(2,:)*u)-2*real(u0'*q_k(2,:)'*q_k(2,:)*u0)^2*t0_0^1.5*inv_pos(sqrt(t0))-real(u'*q_k(2,:)'*q_k(2,:)*u0)*t0_0); %+4*t0_0*square_abs(q_k(3,:)*u0)*real(u0'*q_k(3,:)'*q_k(3,:)*u)-2*real(u0'*q_k(3,:)'*q_k(3,:)*u0)^2*t0_0^1.5*inv_pos(sqrt(t0))-real(u'*q_k(3,:)'*q_k(3,:)*u0)*t0_0);

                d(1) >= eta*Pmax*(0.5*mu(1)*t0^2+1/(2*mu(1))*pow_abs(q_k(2,:)*u,8)); %+0.5*mu(2)*t0^2+1/(2*mu(2))*pow_abs(q_k(3,:)*u,8));



cvx_end
if cvx_optval==+Inf
	break;
end 
t1_0 = t1;
t0_0 = t0;
u0 = u;
d0 = d;
mu(1) = (norm(q_k(2,:)*u,2))^2/t0;
for i = 1:M+1
    u(i) = u(i)/abs(u(i));
end

rsum(ns) = cvx_optval;%检查收敛性
if(ns>2)&&(abs(cvx_optval-r_sum0)<=0.0001)
    break;
end
if (ns>21)
    break;
end
r_sum0 = cvx_optval;

ns = ns+1;
end
if cvx_optval ~= +inf
result(p) = cvx_optval;
p = p+1;
end
end
sum_result(q) = sum(result(:))/length(result(result>0));
q = q+1;
end
end
% 绘制sum_result与T的关系图
figure;
plot(T_values, sum_result, '-o');
xlabel('T values');
ylabel('Sum result');
title('Sum result vs. T values');
grid on;